//------------------------------------------------------------------------------
// JsonFse - Copyright (c) 2015 by Friedemann Seebass, Germany.
// Diese Bibliothek ist freie Software. Siehe GNU LGPL Notiz in der Datei
// JsonParser.java.
// This library is free software. See the GNU LGPL notice in file
// JsonParser.java.
//------------------------------------------------------------------------------

package JsonFse;

//------------------------------------------------------------------------------
/**
Represents the terminal symbol "false".
@author Friedemann Seebass
*/// fse, 20.10.2015

public class NodeFalse extends NodeValue
{
	String mVal = "false";

	//---------------------------------------------------------------------------

	@Override
	public String getAsString(int columnOffset, boolean hasLabel)
	{
		String str = hasLabel ? mVal : indent(columnOffset) + mVal;
		return str;
	}

	//---------------------------------------------------------------------------
	/**
	Returns the value as an boolean value.
	@return The value as an int value.
	*/// fse, 14.01.2017
	
	public boolean getAsBoolean()
	{
		return mVal.equals("true");
	}

}

//---------------------------------------------------------------------------
//------------------------------------- -------------------------------------
//------------------------ ------------------------- ------------------------
//------------------ ------------------ ------------------ ------------------
//-------------- -------------- --------------- -------------- --------------
