//------------------------------------------------------------------------------
// JsonFse - Copyright (c) 2015 by Friedemann Seebass, Germany.
// Diese Bibliothek ist freie Software. Siehe GNU LGPL Notiz in der Datei
// JsonParser.java.
// This library is free software. See the GNU LGPL notice in file
// JsonParser.java.
//------------------------------------------------------------------------------

package JsonFse;

//------------------------------------------------------------------------------
/**
Represents a number in a JSON object. In JSON terminology a number is a string
consisting out of digits and/or ".", "e", "E", "-".
number = int | int frac | int exp | int , frac , exp ;
@author Friedemann Seebass
*/// fse, 20.10.2015

public class NodeNumber extends NodeValue
{
	protected final String mString;

	//---------------------------------------------------------------------------
	/**
	Sets the member variable mString.
	@param str The string the member mString is to be set.
	*/// 25.10.2015
	
	NodeNumber(String str)
	{
		mString = str;
	}

	//---------------------------------------------------------------------------
	
	@Override
	public String getAsString(int columnOffset, boolean hasLabel)
	{
		String str = hasLabel ? mString : indent(columnOffset) + mString;
		return str;
	}
	
	//---------------------------------------------------------------------------
	/**
	Returns the value as an int value.
	@return The value as an int value.
	*/// fse, 14.01.2017
	
	public int getAsInt()
	{
		return Integer.parseInt(mString);
	}

}

//---------------------------------------------------------------------------
//------------------------------------- -------------------------------------
//------------------------ ------------------------- ------------------------
//------------------ ------------------ ------------------ ------------------
//-------------- -------------- --------------- -------------- --------------
