//------------------------------------------------------------------------------
// JsonFse - Copyright (c) 2015 by Friedemann Seebass, Germany.
// Diese Bibliothek ist freie Software. Siehe GNU LGPL Notiz in der Datei
// JsonParser.java.
// This library is free software. See the GNU LGPL notice in file
// JsonParser.java.
//------------------------------------------------------------------------------

package JsonFse;

//------------------------------------------------------------------------------
/**
Represents a JSON String.
@author Friedemann Seebass
*/// fse, 20.10.2015

public class NodeString extends NodeValue
{
	protected String mString;

	NodeString(String str)
	{
		if (str.charAt(0) == '\"')
			mString = str; 
		else
			mString = "\"" + str + "\"";
	}
	
	@Override
	public String getAsString(int columnOffset, boolean hasLabel)
	{
		String str = hasLabel ? mString : indent(columnOffset) + mString;
				return str;
	}
	
	//---------------------------------------------------------------------------
	/**
	In JSON all strings are surrounded by quotation marks. These are regularly
	superfluous for further processing. This method returns the string without
	these quotes.
	@return The string without the leading and trailing quotes.
	*/// fse, 07.11.2015
	
	@Override
	public String getAsStrippedString()
	{
		String str = mString;
		if (str.charAt(0) == '\"' && str.charAt(str.length()-1) == '\"')
			str = str.substring(1, str.length()-1);
		return str;
	}
}

//---------------------------------------------------------------------------
//------------------------------------- -------------------------------------
//------------------------ ------------------------- ------------------------
//------------------ ------------------ ------------------ ------------------
//-------------- -------------- --------------- -------------- --------------
