/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package JsonFse;

import org.junit.Test;
import static org.junit.Assert.*;

/**

 @author fs
 */
public class JsonObjTest
{
	String mNl = System.getProperty("line.separator");
	
	public JsonObjTest()
	{
	}

	/**
	 * Test of getNodeObj method, of class JsonObj.
	 */
	@Test
	public void testGetNodeObj()
	{
		JsonObj instance  = new JsonObj();
		String  expResult = "{  }";
		String  result    = instance.getNodeObj().getAsString();

		System.out.println(getClass().getName() + ".getNodeObj");
		assertEquals(expResult, result);
		
		instance.addPair("label", "string");
		result = instance.getNodeObj().getAsString();
		expResult = "{ \"label\" : \"string\" }";
		assertEquals(expResult, result);
		
		instance.addPair("labelNum", -1.234);
		result = instance.getNodeObj().getAsString();
		expResult = "{" + mNl + "   \"label\" : \"string\"," + mNl + "   \"labelNum\" : -1.234" + mNl + "}";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of getNext method, of class JsonObj.
	 */
	@Test
	public void testGetNext()
	{
		JsonObj instance = new JsonObj();
		String  result, expResult;
		
		System.out.println(getClass().getName() + ".getNext");
		instance.addPair("label", "string");
		instance.addPair("labelNull");
		instance.addPair("numLabel", -123.4);
		result = instance.getNext().getAsString();
		expResult = "\"label\" : \"string\"";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
		
		result = instance.getNext().getAsString();
		expResult = "\"labelNull\" : null";
		assertEquals(expResult, result);
		
		result = instance.getNext().getAsString();
		expResult = "\"numLabel\" : -123.4";
		assertEquals(expResult, result);
	}

	/**
	 * Test of get method, of class JsonObj.
	 */
	@Test
	public void testGet()
	{
		JsonObj instance = new JsonObj();
		String  result, expResult;
		
		System.out.println(getClass().getName() + ".get");
		instance.addPair("label", "string");
		instance.addPair("label2");
		instance.addPair("numLabel", -123.4);
		result = instance.get(0).getAsString();
		expResult = "\"label\" : \"string\"";
		assertEquals(expResult, result);
		
		result = instance.get(2).getAsString();
		expResult = "\"numLabel\" : -123.4";
		assertEquals(expResult, result);
	}

	/**
	 * Test of getValueAsString method, of class JsonObj.
	 */
	@Test
	public void testGetValueAsString()
	{
		JsonObj instance = new JsonObj();
		String  result, expResult;
		
		System.out.println(getClass().getName() + ".getValueAsString");
		instance.addPair("label", "string");
		instance.addPair("label2");
		instance.addPair("numLabel", -123.4);
		result = instance.getValueAsString("numLabel");
		expResult = "-123.4";
		assertEquals(expResult, result);
	}

	/**
	 * Test of getValue method, of class JsonObj.
	 */
	@Test
	public void testGetValue()
	{
		JsonObj instance = new JsonObj();
		String  result, expResult;
		
		System.out.println(getClass().getName() + ".getValueAsString");
		instance.addPair("label", "string");
		instance.addPair("label2");
		instance.addPair("numLabel", -123.4);
		result = instance.getValue("numLabel").getAsString();
		expResult = "-123.4";
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testAddPair_String_String()
	{
		JsonObj instance = new JsonObj();
		String  expResult, result;

		System.out.println(getClass().getName() + ".addPair_String_String");
		instance.addPair("label", "string");
		result = instance.getAsString();
		expResult = "{ \"label\" : \"string\" }";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testAddPair_String_double()
	{
		JsonObj instance = new JsonObj();
		String  expResult, result;

		System.out.println(getClass().getName() + ".addPair_String_double");
		instance.addPair("label", -1.234);
		result = instance.getAsString();
		expResult = "{ \"label\" : -1.234 }";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testAddPair_String_boolean()
	{
		JsonObj instance = new JsonObj();
		String  expResult, result;

		System.out.println(getClass().getName() + ".addPair_String_boolean");
		instance.addPair("label", true);
		result = instance.getAsString();
		expResult = "{ \"label\" : true }";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testAddPair_String()
	{
		JsonObj instance = new JsonObj();
		String  expResult, result;

		System.out.println(getClass().getName() + ".addPair_String");
		instance.addPair("label");
		result = instance.getAsString();
		expResult = "{ \"label\" : null }";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testAddPair_String_NodeArray()
	{
		JsonObj   instance = new JsonObj();
		NodeArray na       = new NodeArray();
		String  expResult, result;

		System.out.println(getClass().getName() + ".addPair_String_NodeArray");
		na.add(new NodeTrue());
		na.add(new NodeString("string"));
		na.add(new NodeNumber("-1.234"));
		instance.addPair("label", na);
		result = instance.getAsString();
		expResult = "{" + mNl +
		            "   \"label\" : [" + mNl +
		            "                true, " + mNl + 
		            "                \"string\", " + mNl +
		            "                -1.234" + mNl +
		            "             ]" + mNl +
		            "}";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testAddPair_String_JsonObj()
	{
		JsonObj instance = new JsonObj();
		JsonObj jo       = new JsonObj();
		String  expResult, result;

		System.out.println(getClass().getName() + ".addPair_JsonObj");
		instance.addPair("label", -1.234);
		instance.addPair("jo", jo);
		result = instance.getAsString();
		expResult = "{" + mNl + "   \"label\" : -1.234," + mNl + "   \"jo\" : {  }" + mNl + "}";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of addPair method, of class JsonObj.
	 */
	@Test
	public void testJsonObj()
	{
		String expResult, result;
		String s = "{" +
							"\"name\" : \"Mike\"," +
							"\"age\"  : 23,"       +
							"\"hobbies\" : [ \"fishing\", \"rugby\", \"computer games\" ]" +
					  "}";

		System.out.println(getClass().getName() + ".JsonObj");
		try
		{
			JsonObj jo = new JsonObj(s);
			result = jo.getAsString();
			expResult = "{" + mNl +
							"   \"name\" : \"Mike\"," + mNl +
							"   \"age\" : 23,"       + mNl +
							"   \"hobbies\" : [" + mNl +
			            "                  \"fishing\", " + mNl +
			            "                  \"rugby\", "   + mNl +
			            "                  \"computer games\"" + mNl +
			            "               ]" + mNl +
					  "}";
//			System.out.println(result);
//			System.out.println(expResult);
			assertEquals(expResult, result);
		}
		catch (ParseErrorEx ex)
		{
			System.out.println(ex.getErrMsg());
		}
		
		s = "{" +
					"\"name\"  \"Mike\"," +
					"\"age\"  : 23,"      +
					"\"hobbies\" : [ \"fishing\", \"rugby\", \"computer games\" ]" +
			  "}";		
		try
		{
			JsonObj jo = new JsonObj(s);
//			System.out.println(result);
//			System.out.println(expResult);
		}
		catch (ParseErrorEx ex)
		{
			result = ex.getErrMsg();
			expResult = "{\"name\"  \"Mike\",\"age\"  : 23,\"hobbies\" : [ \"fishing\", \"rugby\", \"computer games\" ]}" + mNl +
			"---------^ errPos: 9" + mNl +
			"':' expected!";
//			System.out.println(result);
//			System.out.println(expResult);
			assertEquals(expResult, result);
		
			s = "{" +
						"\"name\" : \"Mike\"," +
						"\"age\"  : 23,"      +
						"\"hobbies\" : [ \"fishing\", \"rugby\", \"computer games\" " +
				  "}";		
			try
			{
				JsonObj jo = new JsonObj(s);
			}
			catch (ParseErrorEx ex2)
			{
//				System.out.println(ex2.getErrMsg());
				int res    = ex2.getErrPos();
				int expRes = 80;
				assertEquals(expRes, res);
			}
		}
	}
	
	@Test(expected=ParseErrorEx.class)
	public void checkExpectedException() throws ParseErrorEx
	{
		String s = "{" +
							"\"name\"  \"Mike\"," +
							"\"age\"  : 23,"      +
							"\"hobbies\" : [ \"fishing\", \"rugby\", \"computer games\" ]" +
					  "}";
		System.out.println(getClass().getName() + ".JsonObj_Exception");
		JsonObj jo = new JsonObj(s);
	}
}
