/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package JsonFse;

import org.junit.Test;
import static org.junit.Assert.*;

/**

 @author fs
 */
public class NodeArrayTest
{
	String mNl = System.getProperty("line.separator");

	public NodeArrayTest()
	{
	}

	/**
	 * Test of add method, of class NodeArray.
	 */
	@Test
	public void testAdd()
	{
		NodeValue nv        = new NodeString("string");
		NodeArray instance  = new NodeArray();
		String    expResult = "[ \"string\" ]";
		String    result;

		System.out.println(getClass().getName() + ".add");
		
		instance.add(nv);
		result = instance.getAsString();
		assertEquals(expResult, result);
		
		nv = new NodeNumber("123.4");
		instance.add(nv);
		result = instance.getAsString();
		expResult = "[" + mNl + "   \"string\", " + mNl + "   123.4" + mNl + "]";
		assertEquals(expResult, result);
	}

	/**
	 * Test of getAsString method, of class NodeArray.
	 */
	@Test
	public void testGetAsString()
	{
		int       columnOffset = 0;
		boolean   hasLabel     = false;
		NodeArray instance     = new NodeArray();
		String    expResult    = "[  ]";
		String    result       = instance.getAsString(columnOffset, hasLabel);
		NodeValue nv           = new NodeString("string");

		System.out.println(getClass().getName() + ".getAsString");
		assertEquals(expResult, result);
		
		instance.add(nv);
		result = instance.getAsString(columnOffset, hasLabel);
		expResult = "[ \"string\" ]";
		assertEquals(expResult, result);
		
		columnOffset = 5;
		result = instance.getAsString(columnOffset, hasLabel);
		expResult = "     [ \"string\" ]";
		assertEquals(expResult, result);

		nv = new NodeNull();
		instance.add(nv);
		result = instance.getAsString(columnOffset, hasLabel);
		expResult = "     [" + mNl + "        \"string\", " + mNl + "        null" + mNl + "     ]";
//		System.out.println(result);
//		System.out.println(expResult);
		assertEquals(expResult, result);
	}

	/**
	 * Test of setIdx method, of class NodeArray.
	 */
	@Test
	public void testSetIdx()
	{
		int       idx      = 3;
		NodeArray instance = new NodeArray();
		int       expIdx;
		
		System.out.println(getClass().getName() + ".setIdx");
		instance.setIdx(idx);
		expIdx = instance.mNodeElements.mIdx;
		assertEquals(expIdx, idx);
	}

	/**
	 * Test of getNext method, of class NodeArray.
	 */
	@Test
	public void testGetNext()
	{
		NodeArray instance = new NodeArray();
		String    result, expResult;
		
		System.out.println(getClass().getName() + ".getNext");
		instance.add(new NodeString("string"));
		instance.add(new NodeFalse());
		instance.add(new NodeNumber("123.4"));
		result = instance.getNext().getAsString();
		expResult = "\"string\"";
		assertEquals(expResult, result);
		
		result = instance.getNext().getAsString();
		expResult = "false";
		assertEquals(expResult, result);
		
		result = instance.getNext().getAsString();
		expResult = "123.4";
		assertEquals(expResult, result);
		
		instance.setIdx(1);
		result = instance.getNext().getAsString();
		expResult = "false";
		assertEquals(expResult, result);
	}

	/**
	 * Test of get method, of class NodeArray.
	 */
	@Test
	public void testGet()
	{
		NodeArray instance = new NodeArray();
		String    result, expResult;
		
		System.out.println(getClass().getName() + ".get");
		instance.add(new NodeTrue());
		instance.add(new NodeNull());
		instance.add(new NodeNumber("-123.4"));
		result = instance.get(0).getAsString();
		expResult = "true";
		assertEquals(expResult, result);
		
		result = instance.get(2).getAsString();
		expResult = "-123.4";
		assertEquals(expResult, result);
	}

	/**
	 * Test of size method, of class NodeArray.
	 */
	@Test
	public void testSize()
	{
		NodeArray instance = new NodeArray();
		int       result, expResult;
		
		System.out.println(getClass().getName() + ".size");
		instance.add(new NodeTrue());
		instance.add(new NodeNull());
		instance.add(new NodeNumber("-123.4"));
		result = instance.size();
		expResult = 3;
		assertEquals(expResult, result);
	}
	
}
